"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _Err_expected, _Err_ErrorFunc, _Err_message, _Err_findError;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Err = void 0;
/**
 * Err class is an Error handling class to check your method or variable or anything you want and returned expected message and error
 * @param T type of callback
 * @param U type of expected returned type
 * @param M type of message
 */
class Err {
    /**
     *
     * @param method is an method or property you want to validate
     * @param expected is an something you want to validate quality to return element in method property
     * @param ErrorFunc is an method when method returned false this specific class constructor run
     * @param message is an property you want to returned as message to user
     */
    constructor(method, expected, ErrorFunc, message) {
        /**
         * @property expected is an something you want to validate quality to return element in method property
         */
        _Err_expected.set(this, void 0);
        /**
         * @property ErrorFunc is an method when method returned false this specific class constructor run
         */
        _Err_ErrorFunc.set(this, void 0);
        /**
         * @property message is an property you want to returned as message to user
         */
        _Err_message.set(this, void 0);
        /**
         * this method get error type if you have any error
         * @return name of error
         * @return true if anything will be fine
         */
        _Err_findError.set(this, (error) => {
            if (error instanceof RangeError) {
                return {
                    errorType: "RangeError",
                };
            }
            if (error instanceof EvalError) {
                return {
                    errorType: "EvalError",
                };
            }
            if (error instanceof ReferenceError) {
                return {
                    errorType: "ReferenceError",
                };
            }
            if (error instanceof SyntaxError) {
                return {
                    errorType: "SyntaxError",
                };
            }
            if (error instanceof URIError) {
                return {
                    errorType: "URIError",
                };
            }
            if (error instanceof Error) {
                return {
                    errorType: 'Error',
                };
            }
        }
        /**
         * this method get all error if you have any error
         * @return object if have any error
         * @return true if anything will be fine
         */
        );
        /**
         * this method get all error if you have any error
         * @return object if have any error
         * @return true if anything will be fine
         */
        this.getError = () => {
            try {
                if (this.method === __classPrivateFieldGet(this, _Err_expected, "f")) {
                    return false;
                }
                if (this.method !== __classPrivateFieldGet(this, _Err_expected, "f")) {
                    if (__classPrivateFieldGet(this, _Err_ErrorFunc, "f") !== undefined) {
                        throw __classPrivateFieldGet(this, _Err_ErrorFunc, "f");
                    }
                }
                throw new Error();
            }
            catch (err) {
                if (err instanceof Error) {
                    return {
                        errorType: __classPrivateFieldGet(this, _Err_findError, "f").call(this, err),
                        customMessage: __classPrivateFieldGet(this, _Err_message, "f"),
                        message: err.message,
                        errorName: err.name,
                        stack: err.stack,
                        expected: `expected ${__classPrivateFieldGet(this, _Err_expected, "f")} but get ${err.name}`,
                    };
                }
                if (err instanceof RangeError) {
                    return {
                        errorType: __classPrivateFieldGet(this, _Err_findError, "f").call(this, err),
                        customMessage: __classPrivateFieldGet(this, _Err_message, "f"),
                        message: err.message,
                        errorName: err.name,
                        stack: err.stack,
                        expected: `expected ${__classPrivateFieldGet(this, _Err_expected, "f")} but get ${err.name}`,
                    };
                }
                if (err instanceof EvalError) {
                    return {
                        errorType: __classPrivateFieldGet(this, _Err_findError, "f").call(this, err),
                        customMessage: __classPrivateFieldGet(this, _Err_message, "f"),
                        message: err.message,
                        errorName: err.name,
                        stack: err.stack,
                        expected: `expected ${__classPrivateFieldGet(this, _Err_expected, "f")} but get ${err.name}`,
                    };
                }
                if (err instanceof ReferenceError) {
                    return {
                        errorType: __classPrivateFieldGet(this, _Err_findError, "f").call(this, err),
                        customMessage: __classPrivateFieldGet(this, _Err_message, "f"),
                        message: err.message,
                        errorName: err.name,
                        stack: err.stack,
                        expected: `expected ${__classPrivateFieldGet(this, _Err_expected, "f")} but get ${err.name}`,
                    };
                }
                if (err instanceof SyntaxError) {
                    return {
                        errorType: __classPrivateFieldGet(this, _Err_findError, "f").call(this, err),
                        customMessage: __classPrivateFieldGet(this, _Err_message, "f"),
                        message: err.message,
                        errorName: err.name,
                        stack: err.stack,
                        expected: `expected ${__classPrivateFieldGet(this, _Err_expected, "f")} but get ${err.name}`,
                    };
                }
                if (err instanceof URIError) {
                    return {
                        errorType: __classPrivateFieldGet(this, _Err_findError, "f").call(this, err),
                        customMessage: __classPrivateFieldGet(this, _Err_message, "f"),
                        message: err.message,
                        errorName: err.name,
                        stack: err.stack,
                        expected: `expected ${__classPrivateFieldGet(this, _Err_expected, "f")} but get ${err.name}`,
                    };
                }
                return err;
            }
        };
        this.method = method;
        __classPrivateFieldSet(this, _Err_expected, expected, "f");
        __classPrivateFieldSet(this, _Err_ErrorFunc, ErrorFunc, "f");
        __classPrivateFieldSet(this, _Err_message, message, "f");
    }
}
exports.Err = Err;
_Err_expected = new WeakMap(), _Err_ErrorFunc = new WeakMap(), _Err_message = new WeakMap(), _Err_findError = new WeakMap();
