"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckCardNumber = void 0;
const FaToEn_1 = require("./../../parser/number/FaToEn");
const cardNumber_1 = require("../../constants/cardNumber");
/**
 * Checks if a given credit card number is valid and returns a boolean value.
 * @param {string} CardNumber - the credit card number to check
 * @returns {boolean} - true if the credit card number is valid, false otherwise
 */
const CheckCardNumber = (CardNumber) => {
    const CardNumberRegex = /^\d{4}?[\s.-]?\d{4}?[\s.-]?\d{4}?[\s.-]?\d{4}$/g;
    if (CardNumberRegex.test((0, FaToEn_1.Fa_To_En)(CardNumber))) {
        CardNumber = CardNumber.replace(/[\s.-]/g, '');
        CardNumber = CardNumber.slice(0, 6);
        const bankName = cardNumber_1.banks.find((item) => item.id === +CardNumber);
        if (bankName)
            return true;
    }
    return false;
};
exports.CheckCardNumber = CheckCardNumber;
