"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdNumberFind = void 0;
const idNumber_1 = require("../../constants/idNumber");
const FaToEn_1 = require("../../parser/number/FaToEn");
/**
 * Finds the province and city associated with the given ID number.
 * @param {string} id - The ID number to search for.
 * @returns {idNumberFindType | undefined | boolean} - An object containing the province and city if found, false if not found, or undefined if the input is invalid.
 */
const IdNumberFind = (id) => {
    id = (0, FaToEn_1.Fa_To_En)(id.slice(0, 3));
    const findCity = idNumber_1.idNumbersByCity.find((item) => item.from === id || item.to === id);
    if (findCity) {
        return { province: findCity.province, city: findCity.city };
    }
    return false;
};
exports.IdNumberFind = IdNumberFind;
