"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.letterCount = void 0;
/**
 * Takes in a string and returns an object containing the count of each letter in the string.
 * @param {string} letter - the string to count the letters of
 * @returns An object containing the count of each letter in the string.
 */
const letterCount = (letter) => {
    var _a;
    const letterFix = (_a = letter.match(/(\w)/g)) !== null && _a !== void 0 ? _a : '';
    const words = {};
    for (let i = 0; i < letterFix.length; i++) {
        const word = letterFix[i];
        if (!words[word]) {
            words[word] = 1;
        }
        else {
            words[word]++;
        }
    }
    return words;
};
exports.letterCount = letterCount;
