"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WordCount = void 0;
/**
 * Takes in a sentence and returns an object containing the count of each word in the sentence.
 * @param {string} sentence - the sentence to count the words in
 * @returns {WordCountType} - an object containing the count of each word in the sentence
 */
const WordCount = (sentence) => {
    var _a;
    const splitSentence = (_a = sentence.match(/(\w+)/g)) !== null && _a !== void 0 ? _a : '';
    const words = {};
    for (let i = 0; i < splitSentence.length; i++) {
        const word = splitSentence[i];
        if (!words[word]) {
            words[word] = 1;
        }
        else {
            words[word]++;
        }
    }
    return words;
};
exports.WordCount = WordCount;
