"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const phoneNumber_1 = require("../phoneNumber");
const globals_1 = require("@jest/globals");
/**
 * A test suite to check if the given phone numbers belong to the correct operator.
 * @returns None
 */
(0, globals_1.describe)('Operator Check', () => {
    /**
     * Tests whether a given phone number is an MCI number.
     * @param {string} phoneNumber - The phone number to test.
     * @returns {boolean} - True if the phone number is an MCI number, false otherwise.
     */
    (0, globals_1.test)('MCI', () => {
        (0, globals_1.expect)((0, phoneNumber_1.isMCI)('989113456787')).toBe(true);
    });
    /**
     * Test function to check if a given phone number is an MTN number.
     * @param {string} phoneNumber - The phone number to check.
     * @returns {boolean} - Returns true if the phone number is an MTN number, false otherwise.
     */
    (0, globals_1.test)('MTN', () => {
        (0, globals_1.expect)((0, phoneNumber_1.isMTN)('+989333456787')).toBe(true);
    });
    /**
     * Tests whether a given phone number is an MCI number.
     * @param {string} phoneNumber - The phone number to test.
     * @returns {boolean} - True if the phone number is an MCI number, false otherwise.
     */
    (0, globals_1.test)('MCI', () => {
        (0, globals_1.expect)((0, phoneNumber_1.isMCI)('00989163456787')).toBe(true);
    });
    /**
     * Tests whether a given phone number is a valid Rightel number.
     * @param {string} phoneNumber - The phone number to test.
     * @returns {boolean} - True if the phone number is a valid Rightel number, false otherwise.
     */
    (0, globals_1.test)('Rightel', () => {
        (0, globals_1.expect)((0, phoneNumber_1.isRightel)('09213456787')).toBe(true);
    });
});
