"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const globals_1 = require("@jest/globals");
const findPostalCode_1 = require("../postalCode/findPostalCode");
/**
 * Tests the PostalCodeFind function to ensure that it returns the correct province and city
 * for a given postal code.
 * @returns None
 */
(0, globals_1.describe)('Card', () => {
    /**
     * Tests the PostalCodeFind function to ensure that it returns the correct province and city
     * for a given postal code.
     * @returns None
     */
    (0, globals_1.test)('Card is Valid', () => {
        /**
         * Tests the PostalCodeFind function to ensure that it correctly returns the expected province and city
         * for the given postal code.
         * @param {string} postalCode - The postal code to test.
         * @returns None
         */
        (0, globals_1.expect)((0, findPostalCode_1.PostalCodeFind)('۵۹۴۳۲')).toMatchObject({
            province: 'آذربایجان غربی',
            city: 'بوکان',
        });
        /**
         * Tests the PostalCodeFind function to ensure that it returns the expected province and city
         * for the given postal code.
         * @param {string} postalCode - The postal code to test.
         * @returns None
         */
        (0, globals_1.expect)((0, findPostalCode_1.PostalCodeFind)('63511')).toMatchObject({
            province: 'خوزستان',
            city: 'ماهشهر',
        });
    });
});
